#include "spacegeometry.h"
#include <math.h>

POINT v[48];
int p[48], p2[] = {0, 1, 17, 16, 9, 8, 2, 3, 32, 33, 19, 18, 4, 5, 42, 43, 38, 39, 6, 7, 15, 14, 40, 41, 24, 25, 22, 23, 10, 11, 26, 27, 35, 34, 20, 21, 28, 29, 45, 44, 37, 36, 30, 31, 12, 13, 47, 46},
	p3[] = {0, 8, 15, 7, 24, 11, 12, 31, 27, 35, 36, 28, 3, 32, 39, 4, 1, 2, 18, 17, 25, 26, 21, 22, 29, 30, 46, 45, 5, 6, 41, 42, 9, 10, 23, 16, 19, 20, 34, 33, 37, 38, 43, 44, 13, 14, 40, 47};

double dst = 3.;

/*
void drawoct(double a[], POINT v[])
{
	int i;
	POINT Q;
	double x0, y0, d;

	Q = a * v[0];
	d = dst / (dst - Q.z);
	x0 = Q.x * d;
	y0 = Q.y * d;
	printf("connect %f %f ", x0, y0);
	for(i = 1; i < 8; i++) {
		Q = a * v[i];
		d = dst / (dst - Q.z);
		printf("%f %f ", Q.x * d, Q.y * d);
	}
	printf("%f %f\n", x0, y0);

}
*/

int main(int argc, char *argv[])
{
	double a[9], b[9], c[9];
	POINT dr[6], dr2[8], dr3[12];
	double s = 0.5, t = 0.1, sq2 = sqrt(2.);
	int i, j;

	if(argc > 1) s = atof(argv[1]);
	if(argc > 2) t = atof(argv[2]);
	if(argc > 3) dst = atof(argv[3]);
	for(i = 0; i < 48; i++) p[i] = i;
	for(i = 0; i < 6; i++) dr[i].x = dr[i].y = dr[i].z = 0.;
	dr[0].z = dr[1].x = dr[2].y = 1.;
	dr[3].z = dr[4].x = dr[5].y = -1.;
	for(i = 0; i < 4; i++) dr2[i].z = 1.;
	for( ; i < 8; i++) dr2[i].z = -1.;
	dr2[0].y = dr2[1].y = dr2[4].y = dr2[5].y = 1.;
	dr2[2].y = dr2[3].y = dr2[6].y = dr2[7].y = -1.;
	dr2[0].x = dr2[3].x = dr2[4].x = dr2[7].x = 1.;
	dr2[1].x = dr2[2].x = dr2[5].x = dr2[6].x = -1.;
	for(i = 0; i < 4; i++) dr3[i].y = 0;
	for( ; i < 8; i++) dr3[i].x = 0;
	for( ; i < 12; i++) dr3[i].z = 0;
	dr3[0].x = dr3[1].x = dr3[8].x = dr3[11].x = 1.;
	dr3[2].x = dr3[3].x = dr3[9].x = dr3[10].x = -1.;
	dr3[4].y = dr3[5].y = dr3[8].y = dr3[9].y = 1.;
	dr3[6].y = dr3[7].y = dr3[10].y = dr3[11].y = -1.;
	dr3[0].z = dr3[3].z = dr3[4].z = dr3[7].z = 1.;
	dr3[1].z = dr3[2].z = dr3[5].z = dr3[6].z = -1.;
	a[0] = a[8] = cos(s);
	a[1] = a[3] = a[5] = a[7] = 0.;
	a[4] = 1.;
	a[6] = sin(s); a[2] = -a[6];
	b[0] = 1.; b[1] = b[2] = b[3] = b[6] = 0.;
	b[4] = b[8] = cos(t);
	b[7] = sin(t); b[5] = -b[7];
	mulp(b, a, c);
	for(i = 0; i < 9; i++) a[i] = c[i];
	v[0].x = v[7].x = (3. + sq2) / 7.; v[0].y = v[3].y = (2 * sq2 - 1.) / 7.;
	v[1].x = v[6].x = v[0].y; v[1].y = v[2].y = v[0].x;
	v[2].x = v[5].x = -v[1].x;
	v[3].x = v[4].x = -v[0].x;
	v[4].y = v[7].y = -v[0].y;
	v[5].y = v[6].y = -v[1].y;
	for(i = 0; i < 8; i++) {
		v[i].z = v[i + 8].x = v[i + 16].y = 1.;
		v[i + 8].y = v[i + 16].z = v[i + 24].y = v[i + 32].y = v[i + 40].z = v[i].y;
		v[i + 8].z = v[i + 16].x = v[i + 24].x = v[i + 32].z = v[i + 40].x = v[i].x;
		v[i + 24].z = v[i + 32].x = v[i + 40].y = -1.;
	}
	printf("gray 0.7\n");
	for(i = 0; i < 6; i++) drawpolygon(a, v, p + 8 * i, 8, dst);
	for(i = 0; i < 8; i++) drawpolygon(a, v, p2 + i * 6, 6, dst);
	printf("gray 0\n");
	for(i = 0; i < 6; i++) {
		if((a * dr[i]) * dr[0] > 1. / dst) drawpolygon(a, v, p + 8 * i, 8, dst);
	}
	for(i = 0; i < 8; i++) {
		if((a * dr2[i]) * dr[0] > sqrt(3.) / dst) drawpolygon(a, v, p2 + i * 6, 6, dst);
	}
	for(i = 0; i < 12; i++) {
		if((a * dr3[i]) * dr[0] > sq2 /dst) drawpolygon(a, v, p3 + i * 4, 4, dst);
	}
	return 0;
}
