#include "spacegeometry.h"
#include <math.h>

POINT v[24];
int p[24], p2[] = {0, 1, 8, 11, 5, 4, 1, 2, 12, 15, 9, 8, 2, 3, 16, 19, 13, 12, 0, 4, 7, 17, 16, 3, 5, 6, 20, 21, 10, 11, 9, 10, 21, 22, 14, 15, 13, 14, 22, 23, 18, 19, 17, 18, 23, 20, 6, 7};

double dst = 3.;

/*
void drawrct(double a[], POINT v[])
{
	int i;
	POINT Q;
	double x0, y0, d;

	Q = a * v[0];
	d = dst / (dst - Q.z);
	x0 = Q.x * d;
	y0 = Q.y * d;
	printf("connect %f %f ", x0, y0);
	for(i = 1; i < 4; i++) {
		Q = a * v[i];
		d = dst / (dst - Q.z);
		printf("%f %f ", Q.x * d, Q.y * d);
	}
	printf("%f %f\n", x0, y0);

}
*/

int main(int argc, char *argv[])
{
	double a[9], b[9], c[9];
	POINT dr[6], dr2[8];
	double s = 0.5, t = 0.1, sq3 = sqrt(3.);
	int i, j;

	if(argc > 1) s = atof(argv[1]);
	if(argc > 2) t = atof(argv[2]);
	if(argc > 3) dst = atof(argv[3]);
	for(i = 0; i < 24; i++) p[i] = i;
	for(i = 0; i < 6; i++) dr[i].x = dr[i].y = dr[i].z = 0.;
	dr[0].z = dr[1].x = dr[2].y = 1.;
	dr[3].x = dr[4].y = dr[5].z = -1.;
	for(i = 0; i < 4; i++) dr2[i].z = 1.;
	for( ; i < 8; i++) dr2[i].z = -1.;
	dr2[0].x = dr2[3].x = dr2[4].x = dr2[7].x = 1.;
	dr2[1].x = dr2[2].x = dr2[5].x = dr2[6].x = -1.;
	dr2[0].y = dr2[1].y = dr2[4].y = dr2[5].y = 1.;
	dr2[2].y = dr2[3].y = dr2[6].y = dr2[7].y = -1.;
	a[0] = a[8] = cos(s);
	a[1] = a[3] = a[5] = a[7] = 0.;
	a[4] = 1.;
	a[6] = sin(s); a[2] = -a[6];
	b[0] = 1.; b[1] = b[2] = b[3] = b[6] = 0.;
	b[4] = b[8] = cos(t);
	b[7] = sin(t); b[5] = -b[7];
	mulp(b, a, c);
	for(i = 0; i < 9; i++) a[i] = c[i];
	for(i = 0; i < 24; i++) v[i].x = v[i].y = v[i].z = 0.;
	for(i = 0; i < 4; i++) v[i].z = 1.;
	for( ; i < 8; i++) v[i].x = 1.;
	for( ; i < 12; i++) v[i].y = 1.;
	for( ; i < 16; i++) v[i].x = -1.;
	for( ; i < 20; i++) v[i].y = -1.;
	for( ; i < 24; i++) v[i].z = -1.;
	v[0].x = v[1].y = v[4].z = v[5].y = v[8].z = v[11].x = v[12].z = v[15].y = v[16].z = v[17].x = v[20].x = v[21].y = 0.5;
	v[2].x = v[3].y = v[6].z = v[7].y = v[9].x = v[10].z = v[13].y = v[14].z = v[18].z = v[19].x = v[22].x = v[23].y = -0.5;
	printf("gray 0.7\n");
	for(i = 0; i < 6; i++) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 8; i++) drawpolygon(a, v, p2 + 6 * i, 6, dst);
	printf("gray 0\n");
	for(i = 0; i < 6; i++) if((a * dr[i]) * dr[0] > 1. / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 8; i++) if((a * dr2[i]) * dr[0] > 1.5 / dst) drawpolygon(a, v, p2 + 6 * i, 6, dst);
	return 0;
}
