#include "spacegeometry.h"
#include <math.h>

POINT v[24];
int p[24],
	p2[] = {0, 3, 7, 4, 0, 1, 11, 8, 1, 2, 15, 12, 2, 3, 19, 16, 4, 5, 9, 8, 10, 11, 12, 13, 14, 15, 16, 17, 6, 7, 19, 18, 5, 9, 21, 20, 10, 13, 22, 21, 14, 17, 23, 22, 6, 18, 23, 20},
	p3[] = {0, 4, 8, 1, 11, 12, 2, 15, 16, 3, 7, 19, 5, 6, 20, 10, 9, 21, 14, 13, 22, 17, 18, 23};

double dst = 3.;
/*
void drawrct(double a[], POINT v[])
{
	int i;
	POINT Q;
	double x0, y0, d;

	Q = a * v[0];
	d = dst / (dst - Q.z);
	x0 = Q.x * d;
	y0 = Q.y * d;
	printf("connect %f %f ", x0, y0);
	for(i = 1; i < 4; i++) {
		Q = a * v[i];
		d = dst / (dst - Q.z);
		printf("%f %f ", Q.x * d, Q.y * d);
	}
	printf("%f %f\n", x0, y0);

}
*/

int main(int argc, char *argv[])
{
	double a[9], b[9], c[9];
	POINT dr[6], dr2[12], dr3[8];
	double s = 0.5, t = 0.1, e = sqrt(2.) - 1., sq2 = sqrt(2.);
	int i, j;

	if(argc > 1) s = atof(argv[1]);
	if(argc > 2) t = atof(argv[2]);
	if(argc > 3) dst = atof(argv[3]);
	for(i = 0; i < 24; i++) p[i] = i;
	for(i = 0; i < 6; i++) dr[i].x = dr[i].y = dr[i].z = 0.;
	dr[0].z = dr[1].x = dr[2].y = 1.;
	dr[3].x = dr[4].y = dr[5].z = -1.;
	for(i = 0; i < 4; i++) dr2[i].z = 1.;
	for(i = 4; i < 8; i++) dr2[i].z = 0.;
	dr2[0].x = dr2[4].x = dr2[7].x = 1.;
	dr2[2].x = dr2[5].x = dr2[6].x = -1.;
	dr2[1].x = dr2[3].x = 0.;
	dr2[1].y = dr2[4].y = dr2[5].y = 1.;
	dr2[3].y = dr2[6].y = dr2[7].y = -1.;
	dr2[0].y = dr2[2].y = 0.;
	for(i = 8; i < 12; i++) dr2[i].z = -sq2;
	dr2[8].x = dr2[11].x = dr2[8].y = dr2[9].y = 1.;
	dr2[9].x = dr2[10].x = dr2[10].y = dr2[11].y = -1.;
	for(i = 0; i < 4; i++) dr3[i].z = 1.;
	dr3[0].x = dr3[3].x = 1.;
	dr3[1].x = dr3[2].x = -1.;
	dr3[0].y = dr3[1].y = 1.;
	dr3[2].y = dr3[3].y = -1.;
	for(i = 4; i < 8; i++) dr3[i].z = 1. - 2. * sq2;
	dr3[8].y = dr3[9].x = dr3[10].y = dr3[11].x = 0.;
	dr3[8].x = dr3[9].y = 4. - sq2;
	dr3[10].x = dr3[11].y = sq2 - 4.;
	a[0] = a[8] = cos(s);
	a[1] = a[3] = a[5] = a[7] = 0.;
	a[4] = 1.;
	a[6] = sin(s); a[2] = -a[6];
	b[0] = 1.; b[1] = b[2] = b[3] = b[6] = 0.;
	b[4] = b[8] = cos(t);
	b[7] = sin(t); b[5] = -b[7];
	mulp(b, a, c);
	for(i = 0; i < 9; i++) a[i] = c[i];
	for(i = 0; i < 4; i++) v[i].z = 1.;
	for(i = 20; i < 24; i++) v[i].z = -1.;
	for(i = 4; i < 8; i++) v[i].x = 1.;
	for(i = 12; i < 16; i++) v[i].x = -1.;
	for(i = 8; i < 12; i++) v[i].y = 1.;
	for(i = 16; i < 20; i++) v[i].y = -1.;
	v[0].x = v[3].x = v[8].x = v[9].x = v[18].x = v[19].x = e;
	v[1].x = v[2].x = v[10].x = v[11].x = v[16].x = v[17].x =  -e;
	v[0].y = v[1].y = v[4].y = v[5].y = v[12].y = v[13].y = e;
	v[2].y = v[3].y = v[23].y = v[6].y = v[7].y = v[14].y = v[15].y = -e;
	v[4].z = v[7].z = v[8].z = v[11].z = v[12].z = v[15].z = v[16].z = v[19].z = e;
	v[5].z = v[6].z = v[9].z = v[10].z = v[13].z = v[14].z = v[17].z = v[18].z = -e;
	v[20].y = v[22].y = v[21].x = v[23].x = 0.;
	v[20].x = v[21].y = 2. - sq2;
	v[22].x = v[23].y = sq2 - 2.;
	printf("gray 0.7\n");
	for(i = 0; i < 6; i++) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 12; i++) drawpolygon(a, v, p2 + 4 * i, 4, dst);
	for(i = 0; i < 8; i++) drawpolygon(a, v, p3 + 3 * i, 3, dst);
	printf("gray 0\n");
	for(i = 0; i < 6; i++) if((a * dr[i]) * dr[0] > 1. / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 8; i++) if((a * dr2[i]) * dr[0] > sq2 / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	for( ; i < 12; i++) if((a * dr2[i]) * dr[0] > 2. / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 4; i++) if((a * dr3[i]) * dr[0] > (2. * sq2 - 1.) / dst) drawpolygon(a, v, p3 + 3 * i, 3, dst);
	for( ; i < 8; i++) if((a * dr3[i]) * dr[0] > (9. - 4. * sq2) / dst) drawpolygon(a, v, p3 + 3 * i, 3, dst);
	return 0;
}
