#include "spacegeometry.h"
#include <math.h>

POINT v[12];
int p[] = {0, 4, 3, 7, 0, 8, 1, 11, 4, 8, 5, 9, 3, 9, 2, 10, 6, 10, 7, 11, 1, 5, 2, 6},
	p2[] = {0, 4, 8, 3, 4, 9, 3, 7, 10, 0, 7, 11, 1, 5, 8, 2, 5, 9, 2, 6, 10, 1, 6, 11};

double dst = 3.;
/*
void drawpolygon(double a[], POINT v[], int p[], int n)
{
	int i;
	POINT Q;
	double x0, y0, d;

	Q = a * v[p[0]];
	d = dst / (dst - Q.z);
	x0 = Q.x * d;
	y0 = Q.y * d;
	printf("connect %f %f ", x0, y0);
	for(i = 1; i < n; i++) {
		Q = a * v[p[i]];
		d = dst / (dst - Q.z);
		printf("%f %f ", Q.x * d, Q.y * d);
	}
	printf("%f %f\n", x0, y0);

}

void mulp(double a[], double b[], double c[])
{
	int i, j, k;

	for(i = 0; i < 3; i++) {
		for(k = 0; k < 3; k++) {
			double s = 0.;
			for(j = 0; j < 3; j++) s += a[i * 3 + j] * b[j * 3 + k];
			c[i * 3 + k] = s;
		}
	}
}
*/
int main(int argc, char *argv[])
{
	double a[9], b[9], c[9];
	POINT dr[6], dr2[12];
	double s = 0.5, t = 0.1;
	int i, j;

	if(argc > 1) s = atof(argv[1]);
	if(argc > 2) t = atof(argv[2]);
	if(argc > 3) dst = atof(argv[3]);
	a[0] = a[8] = cos(s);
	a[1] = a[3] = a[5] = a[7] = 0.;
	a[4] = 1.;
	a[6] = sin(s); a[2] = -a[6];
	b[0] = 1.; b[1] = b[2] = b[3] = b[6] = 0.;
	b[4] = b[8] = cos(t);
	b[7] = sin(t); b[5] = -b[7];
	mulp(b, a, c);
	for(i = 0; i < 9; i++) a[i] = c[i];
	for(i = 0; i < 4; i++) v[i].y = 0.;
	v[0].x = v[1].x = v[0].z = v[3].z = 1.;
	v[2].x = v[3].x = v[1].z = v[2].z = -1.;
	for(i = 4; i < 8; i++) v[i].x = 0.;
	v[4].y = v[5].y = v[4].z = v[7].z = 1.;
	v[6].y = v[7].y = v[5].z = v[6].z = -1.;
	for(i = 8; i < 12; i++) v[i].z = 0.;
	v[8].x = v[11].x = v[8].y = v[9].y = 1.;
	v[9].x = v[10].x = v[10].y = v[11].y = -1.;
	for(i = 0; i < 6; i++) dr[i].x = dr[i].y = dr[i].z = 0.;
	dr[0].z = dr[1].x = dr[2].y = 1.;
	dr[3].x = dr[4].y = dr[5].z = -1.;
	for(i = 0; i < 4; i++) dr2[i].z = 1.;
	for( ; i < 8; i++) dr2[i].z = -1.;
	dr2[0].x = dr2[3].x = dr2[4].x = dr[7].x = 1.;
	dr2[1].x = dr2[2].x = dr2[5].x = dr[6].x = -1.;
	dr2[0].y = dr2[1].y = dr2[4].y = dr[5].y = 1.;
	dr2[2].y = dr2[3].y = dr2[6].y = dr[7].y = -1.;
	printf("gray 0.7\n");
	for(i = 0; i < 6; i++) drawpolygon(a, v, p + 4 * i, 4, dst);
	printf("gray 0\n");
	for(i = 0; i < 6; i++) if((a * dr[i]) * dr[0] > 1. / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	for(i = 0; i < 8; i++) if((a * dr2[i]) * dr[0] > 2. / dst) drawpolygon(a, v, p2 + 3 * i, 3, dst);
	return 0;
}
