#include "spacegeometry.h"
#include <math.h>

POINT v[14];
int p[] = {0, 6, 1, 9, 0, 6, 2, 7, 0, 7, 3, 8, 0, 8, 4, 9, 1, 6, 2, 10, 2,7, 3, 11, 3, 8, 4, 12, 1, 9, 4, 13, 1, 10, 5, 13, 2, 10, 5, 11, 3, 11, 5, 12, 4, 12, 5, 13};

double dst = 3.;
/*
void drawpolygon(double a[], POINT v[], int p[], int n)
{
	int i;
	POINT Q;
	double x0, y0, d;

	Q = a * v[p[0]];
	d = dst / (dst - Q.z);
	x0 = Q.x * d;
	y0 = Q.y * d;
	printf("connect %f %f ", x0, y0);
	for(i = 1; i < n; i++) {
		Q = a * v[p[i]];
		d = dst / (dst - Q.z);
		printf("%f %f ", Q.x * d, Q.y * d);
	}
	printf("%f %f\n", x0, y0);

}

void mulp(double a[], double b[], double c[])
{
	int i, j, k;

	for(i = 0; i < 3; i++) {
		for(k = 0; k < 3; k++) {
			double s = 0.;
			for(j = 0; j < 3; j++) s += a[i * 3 + j] * b[j * 3 + k];
			c[i * 3 + k] = s;
		}
	}
}
*/
int main(int argc, char *argv[])
{
	double a[9], b[9], c[9];
	POINT dr[12], d0;
	double s = 0.5, t = 0.1;
	int i;

	if(argc > 1) s = atof(argv[1]);
	if(argc > 2) t = atof(argv[2]);
	if(argc > 3) dst = atof(argv[3]);
	a[0] = a[8] = cos(s);
	a[1] = a[3] = a[5] = a[7] = 0.;
	a[4] = 1.;
	a[6] = sin(s); a[2] = -a[6];
	b[0] = 1.; b[1] = b[2] = b[3] = b[6] = 0.;
	b[4] = b[8] = cos(t);
	b[7] = sin(t); b[5] = -b[7];
	mulp(b, a, c);
	for(i = 0; i < 9; i++) a[i] = c[i];
	for(i = 0; i < 6; i++) v[i].x = v[i].y = v[i].z = 0.;
	v[0].z = v[1].x = v[2].y = 1.;
	v[5].z = v[3].x = v[4].y = -1.;
	for(i = 6; i < 10; i++) v[i].z = 0.5;
	for( ; i < 14; i++) v[i].z = -0.5;
	v[6].x = v[9].x = v[10].x = v[13].x = 0.5;
	v[7].x = v[8].x = v[11].x = v[12].x = -0.5;
	v[6].y = v[7].y = v[10].y = v[11].y = 0.5;
	v[8].y = v[9].y = v[12].y = v[13].y = -0.5;
	d0.z = 1.; d0.x = d0.y = 0.;
	for(i = 0; i < 4; i++) dr[i].z = 1.;
	for( ; i < 8; i++) dr[i].z = 0.;
	for( ; i < 12; i++) dr[i].z = -1.;
	dr[0].x = dr[4].x = dr[7].x = dr[8].x = 1.;
	dr[1].x = dr[3].x = dr[9].x = dr[11].x = 0.;
	dr[2].x = dr[5].x = dr[10].x = dr[6].x = -1.;
	dr[1].y = dr[4].y = dr[5].y = dr[9].y = 1.;
	dr[0].y = dr[2].y = dr[8].y = dr[10].y = 0.;
	dr[3].y = dr[6].y = dr[7].y = dr[11].y = -1.;
	printf("gray 0.7\n");
	for(i = 0; i < 12; i++) drawpolygon(a, v, p + 4 * i, 4, dst);
	printf("gray 0\n");
	for(i = 0; i < 12; i++) if((a * dr[i]) * d0 > 1. / dst) drawpolygon(a, v, p + 4 * i, 4, dst);
	return 0;
}
